#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityLuckyFishCFG.h"
std::auto_ptr<M_ActivityLuckyFishCFG> M_ActivityLuckyFishCFG::msSingleton(nullptr);

int M_ActivityLuckyFishCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityLuckyFishCFGData* M_ActivityLuckyFishCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityLuckyFishCFGData>& M_ActivityLuckyFishCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityLuckyFishCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityLuckyFishCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityLuckyFishCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mminRate = element->IntAttribute("minRate");
		data.mmaxRate = element->IntAttribute("maxRate");
		data.mweight = element->IntAttribute("weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityLuckyFishCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityLuckyFishCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityLuckyFishCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityLuckyFishCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityLuckyFishCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "minRate", data.mminRate);
		LuaCfgHelper::readInt(L, "maxRate", data.mmaxRate);
		LuaCfgHelper::readInt(L, "weight", data.mweight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityLuckyFishCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityLuckyFishCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityLuckyFishCFG* M_ActivityLuckyFishCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityLuckyFishCFG());
	}
	return msSingleton.get();
}

void M_ActivityLuckyFishCFG::Release()
{
	msSingleton.reset(nullptr);
}
